import { AddressSpace } from '@/ua/AddressSpace'
import { UABaseNode } from '@/ua/UABaseNode'
import type { UANodeSet } from '@/ua/UANodeSet'
import { defineStore } from 'pinia'
import { ref } from 'vue'

export const useStore = defineStore('user', {
  state: () => ({
      addressSpace: null as AddressSpace | null,
      rootNode: null as UABaseNode | null,
      selectedNode: ref<UABaseNode | null>(null),
      mapping: new Map<string, IMappingValue>()
  }),
  actions: {
    setAddressSpace(as: AddressSpace) {
      this.addressSpace=as;
      this.rootNode=as.findNode("ns=0;i=84")||null;
      this.selectedNode=null;
    },
    addNodeset(nodeset: UANodeSet) {
      this.addressSpace?.addNodeset(nodeset);
      this.rootNode=this.addressSpace?.findNode("ns=0;i=84")||null;
    }
  }
})

export interface IMappingValue {
  path: string;
  read: string;
  write: string;
}